#include "SendFileThread.h"
#include "MySyncObject.h"		// CMySyncObjectg
#include "SendRecvThread.h"		// CSendRecvThreadg
#include "RingBuff.h"			// CRingBuffg


CSendFileThread::CSendFileThread(CSendRecvThread *pCSendRecvThread, LPSTR pszFileName)
{
	// RXgN^̈o
	m_pCSendRecvThread = pCSendRecvThread;
	m_pszFileName = (LPSTR)calloc(strlen(pszFileName) + 1, sizeof(char));
	DISABLE_C4996
	strcpy(m_pszFileName, pszFileName);
	ENABLE_C4996

	// ϐ̏
	m_fIamZombie = FALSE;
	m_pCMySyncObject = new CMySyncObject();
	m_pCMySyncObject->Initialize();
	m_pCRingBuffCmd = new CRingBuff(CMD_BUFF_SIZE);	// t@CMv/i[p

	m_iSendFileStatus = SEND_FILE_STAT_IDLE;		// Jڏ SEND_FILE_STAT_IDLE/SEND_FILE_STAT_START/SEND_FILE_STAT_ING/SEND_FILE_STAT_END
	m_cSendFileStartRes = 0;						// t@CMJnv(0:l 1:OK -1:G[)
	m_cSendFileEndRes = 0;							// t@CMv(0:l 1:OK -1:G[)
	m_cSendFileAbortRes = 0;						// t@CMfv(0:l 1:OK -1:G[)
	m_dwStart = 0;									// v𑗐M
	m_fdSrcFile = -1;								// Mt@CfBXNv^
	m_lTotalSentSize = 0;							// Mς݃oCg
	m_iWaitCount = 0;								// M҂
}


CSendFileThread::~CSendFileThread()
{
	if(m_pCMySyncObject != NULL)
		m_pCMySyncObject->Uninitialize();
	SAFE_DELETE(m_pCMySyncObject)
	SAFE_FREE(m_pszFileName)
	SAFE_DELETE(m_pCRingBuffCmd)					// t@CMv/i[p
}


UINT CSendFileThread::DoWork()
{
	int			iRet = -1;

	while (!m_fStopFlag)
	{
		Sleep(5);
// t@CMJڏԂɉ̎s
// ɑ΂鏈ƃt@CM̊֐Ŏs܂
		iRet = DoSendFileState();
		if ((iRet == 2) || (iRet == -1))	// M/G[ÃXbh]rɂ
			break;
	}
	// t@Cclose
	if (m_fdSrcFile != -1)
		_close(m_fdSrcFile);
	m_pCMySyncObject->Lock();
	m_fIamZombie = TRUE;		// t@CM/sŃ]r
	m_pCMySyncObject->UnLock();
	return((iRet != -1) ? 0 : -1);
}

//----------------------------------------------
// function
//		t@CMJڏԂɉs
// parameter
//		Ȃ
// return
//		0:Ȃ 1:s 2:M -1:G[
//----------------------------------------------
int CSendFileThread::DoSendFileState()
{
	int iRet = 0;

	if (AnalyzeCmd() == -1)						// Ȃǂ̉ Ԓl-1̎G[
	{
		iRet = -1;
		goto L_END;
	}
	switch (m_iSendFileStatus)
	{
		case SEND_FILE_STAT_IDLE:				// ->MJn҂
			if ((iRet = SendFileStart()) == 1)	// @t@COpenāAMJnvpPbg𑗐M
			{
				m_iSendFileStatus = SEND_FILE_STAT_START;
				m_dwStart = timeGetTime();
			}
			break;
		case SEND_FILE_STAT_START:				// MJn҂->M
			if ((iRet = CheckSendFileStartRes(TIMEOUT_FOR_RES)) == 1)	// Aʃ`FbN
			{
				m_iSendFileStatus = SEND_FILE_STAT_ING;
				m_lTotalSentSize = 0;			// t@CM
				m_iWaitCount = 0;
			}
			break;
		case SEND_FILE_STAT_ING:				// M->M/M->M҂
			if ((iRet = SendFileIng()) == 2)	// M->M҂
			{
				iRet = 1;						// v҂܂ŊƂȂ
				m_iSendFileStatus = SEND_FILE_STAT_END;
				m_dwStart = timeGetTime();
			}
			break;
		case SEND_FILE_STAT_END:				// M҂->I
			if ((iRet = CheckSendFileEndRes(TIMEOUT_FOR_RES)) == 2)
			{
				Locate(1, 10, 2);
				fprintf(stderr, "t@CM\n");
				m_iSendFileStatus = SEND_FILE_STAT_IDLE;
			}
			break;
		case SEND_FILE_STAT_ABORT:				// f҂->I
			if ((iRet = CheckSendFileAbortRes(TIMEOUT_FOR_RES)) == 2)
			{
				Locate(1, 10, 2);
				fprintf(stderr, "t@CMf\n");
				m_iSendFileStatus = SEND_FILE_STAT_IDLE;
			}
			break;
		default:				// mȂJڏ
			iRet = -1;
			break;
	}
L_END:
	if (iRet == -1)
	{
		Locate(1, 8, 1);
		fprintf(stderr, "t@CMG[");
	}
	return(iRet);
}

//----------------------------------------------
// function
//		@t@COpenāAMJnvpPbg𑗐M
// parameter
//		Ȃ
// return
//		1/-1
//----------------------------------------------
int CSendFileThread::SendFileStart()
{
	int iRet = -1;
	struct stat statInfo;			// t@C̏̂߂̕ϐ

	m_cSendFileStartRes = 0;		// M
	// t@COpen
	DISABLE_C4996
	m_fdSrcFile = _open(m_pszFileName, _O_RDONLY | _O_BINARY);
	ENABLE_C4996
	if (m_fdSrcFile == -1)
		goto L_END;
	// t@C̏擾(t@CTCY)
	if (fstat(m_fdSrcFile, &statInfo) != 0)
		goto L_END;
	m_lFileLength = statInfo.st_size;

	// t@C, t@C̑M
	if (SendSendFileStartPacket(m_pszFileName, m_lFileLength) == FALSE)
		goto L_END;
	iRet = 1;
L_END:
	return(iRet);
}


//----------------------------------------------
// function
//		@t@CMJnR}h̑M
// parameter
//		LPSTR	pszFileName	[in]t@C
//		int		iFileLength	[in]t@C
// retun
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendFileThread::SendSendFileStartPacket(LPSTR pszFileName, int iFileLength)
{
	BOOL		fRet = FALSE;
	SendFileStartReqRec	*pSendFileStartReq = NULL;
	int			iPacketSize;
	int			iSize;
	LPBYTE		pbDest = NULL;

	// ʃwb_Ƀf[^i[
	iPacketSize = sizeof(SendFileStartReqRec);
	pSendFileStartReq = (SendFileStartReqRec *)calloc(iPacketSize, sizeof(BYTE));
	memcpy(pSendFileStartReq->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pSendFileStartReq->header.wCommand = htons(CMD_SEND_FILE_START_REQ);
	pSendFileStartReq->header.wDataLen = htons(sizeof(FileInfoRec));

	Locate(1, 8, 2);
	fprintf(stderr, "t@CM %s %d", pszFileName, iFileLength);
	// f[^Ƀf[^i[(t@CTCYAt@C)
	// t@CΉ̂߂UTF-8ɕύXđM
	iSize = 0;
	pbDest = NULL;
	ConvSJistoUtf8((LPBYTE)pszFileName, NULL, &iSize);
	pbDest = (LPBYTE)calloc(iSize, sizeof(BYTE));
	ConvSJistoUtf8((LPBYTE)pszFileName, pbDest, &iSize);

	memcpy(pSendFileStartReq->FileInfo.szFileName, pbDest, iSize);
	DISABLE_C4996
	sprintf(pSendFileStartReq->FileInfo.szFileSize, "%d", iFileLength);
	ENABLE_C4996

	// t@CMJnvpPbg̑M
	fRet = m_pCSendRecvThread->SetSendData((char *)pSendFileStartReq, iPacketSize);

	SAFE_FREE(pbDest)
	SAFE_FREE(pSendFileStartReq);
	return(fRet);
}


//----------------------------------------------
// function
//		At@CMJnṽ`FbN
// parameter
//		DWORD	dwTimeOut	[in]^CAEg
// return
//		0:܂ĂȂ 1: -1:s܂̓^CAEg
//----------------------------------------------
int CSendFileThread::CheckSendFileStartRes(DWORD dwTimeOut)
{
	int		iRet = 0;

	if (GetdwInterval(timeGetTime(), m_dwStart) >= dwTimeOut)	// ^CAEg
	{
		iRet = -1;
		goto L_END;
	}
	if (m_cSendFileStartRes == -1)				// G[
		iRet = -1;
	else if (m_cSendFileStartRes == 1)			// 
		iRet = 1;
L_END:
	return(iRet);
}

//----------------------------------------------
// function
//		Dt@CMṽ`FbN
// parameter
//		DWORD	dwTimeOut	[in]^CAEg
// return
//		0:܂ĂȂ 2: -1:s܂̓^CAEg
//----------------------------------------------
int CSendFileThread::CheckSendFileEndRes(DWORD dwTimeOut)
{
	int		iRet = 0;

	if (GetdwInterval(timeGetTime(), m_dwStart) >= dwTimeOut)	// ^CAEg
	{
		iRet = -1;
		goto L_END;
	}
	if (m_cSendFileEndRes == -1)				// G[
		iRet = -1;
	else if (m_cSendFileEndRes == 1)			// 
		iRet = 2;
L_END:
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMfṽ`FbN
// parameter
//		DWORD	dwTimeOut	[in]^CAEg
// return
//		0:܂ĂȂ 2: -1:s܂̓^CAEg
//----------------------------------------------
int CSendFileThread::CheckSendFileAbortRes(DWORD dwTimeOut)
{
	int		iRet = 0;

	if (GetdwInterval(timeGetTime(), m_dwStart) >= dwTimeOut)	// ^CAEg
	{
		iRet = -1;
		goto L_END;
	}
	if (m_cSendFileAbortRes == -1)				// G[
		iRet = -1;
	else if (m_cSendFileAbortRes == 1)			// 
		iRet = 2;
L_END:
	return(iRet);
}


#define	READ_SIZE	(1024 * 10)			// t@C̓ǂݍݒP(KobƓǂ݂܂)
//----------------------------------------------
// function
//		BCt@CǂݍŃt@CM/t@CMpPbg𑗐M
//		̊֐ŃG[NƂ́AfR}h𑗂̂ǂł傤
// parameter
//		Ȃ
// retun
//		TRUE/FALSE
//----------------------------------------------
int CSendFileThread::SendFileIng()
{
	BOOL			fEnd = FALSE, fRet;
	LPBYTE			pbData = NULL;
	int				iRet = 0, iReadSize;
	SendFileIngRec	*pSendFileIng = NULL;
	int				iPacketSize;

	// t@Cǂݍ
	pbData = (LPBYTE)calloc(READ_SIZE, sizeof(BYTE));
	_lseek(m_fdSrcFile, m_lTotalSentSize, SEEK_SET);
	iReadSize = _read(m_fdSrcFile, pbData, READ_SIZE);
	iPacketSize = sizeof(HeaderRec) + sizeof(SendFileStatRec) + iReadSize;
	pSendFileIng = (SendFileIngRec *)calloc(iPacketSize, sizeof(BYTE));

	// ʃwb_Ƀf[^i[
	memcpy(pSendFileIng->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pSendFileIng->header.wDataLen = htons((WORD)sizeof(SendFileStatRec) + iReadSize);
	// f[^Ƀf[^i[
	DISABLE_C4996
	sprintf(pSendFileIng->Stat.szOffset, "%d", m_lTotalSentSize);	// ǂݍ݈ʒu
	sprintf(pSendFileIng->Stat.szSize, "%d", iReadSize);			// ǂݍ񂾃f[^
	ENABLE_C4996
	if (iReadSize > 0)				// t@C̓r𑗐M
	{
		Locate(1, 9, 1);
		fprintf(stderr, "t@CM %d %d %d\n", m_lTotalSentSize, iReadSize, m_lFileLength);
		// ʃwb_Ƀf[^i[
		pSendFileIng->header.wCommand = htons(CMD_SEND_FILE_ING);
		// f[^Ƀf[^i[
		memcpy(pSendFileIng->bData, pbData, iReadSize);
	}
	else							// t@C̍Ō܂œǂ񂾂̂Ŋ𑗐M
	{
		Locate(1, 10, 1);
		fprintf(stderr, "t@CMvM %d %d\n", m_lTotalSentSize, iReadSize);
		// ʃwb_Ƀf[^i[
		pSendFileIng->header.wCommand = htons(CMD_SEND_FILE_END_REQ);
		fEnd = TRUE;				// t@CM
	}
	// pPbgŜ𑗐Mobt@ɏ
	fRet = m_pCSendRecvThread->SetSendData((char *)pSendFileIng, iPacketSize);
	if (fRet == TRUE)				// pPbg߂
	{
		if (fEnd == TRUE)			// Ō܂őM̂ŏI
			iRet = 2;
		else
		{
			m_lTotalSentSize += iReadSize;	// pPbg߂̂œǂݍ݃|C^XV
			iRet = 1;
		}
	}
	else							// ߂Ȃ̂œǂݍ݃|C^͂̂܂
	{
		Locate(1, 11, 0);
		fprintf(stderr, "Mobt@̋󂫑҂(%d)\n", ++m_iWaitCount);	
		// Mobt@ɏȂ̂łƑ҂
		Sleep(100);					// READ_SIZE𑗐M̂Ɋ|鎞Ԓx҂̂ǂł傤
	}
	SAFE_FREE(pSendFileIng)
	SAFE_FREE(pbData)
	return(iRet);
}


//----------------------------------------------
// function
//		Mf
//		JڏԕύXAfpPbgM
// parameter
//		Ȃ
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendFileThread::SendFileAbort()
{
	BOOL		fRet = FALSE;

	// t@CM̎f
	if (m_iSendFileStatus != SEND_FILE_STAT_ING)
		goto L_END;

	m_iSendFileStatus = SEND_FILE_STAT_ABORT;
	m_dwStart = timeGetTime();
	fRet = SendSendFileAbortPacket();
L_END:
	return(fRet);
}

//----------------------------------------------
// function
//		MfR}h̑M
// parameter
//		Ȃ
// retun
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendFileThread::SendSendFileAbortPacket()
{
	BOOL		fRet = FALSE;
	SendFileAbortReqRec	*pSendFileAbortReq = NULL;
	int			iPacketSize;

	// ʃwb_Ƀf[^i[
	iPacketSize = sizeof(SendFileAbortReqRec);
	pSendFileAbortReq = (SendFileAbortReqRec *)calloc(iPacketSize, sizeof(BYTE));
	memcpy(pSendFileAbortReq->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pSendFileAbortReq->header.wCommand = htons(CMD_SEND_FILE_ABORT_REQ);
	pSendFileAbortReq->header.wDataLen = htons(0);

	Locate(1, 10, 1);
	fprintf(stderr, "t@CMfvM");
	
	// t@CMfpPbg̑M
	fRet = m_pCSendRecvThread->SetSendData((char *)pSendFileAbortReq, iPacketSize);
	SAFE_FREE(pSendFileAbortReq);
	return(fRet);
}


//----------------------------------------------
// function
//		t@CMR}h/̉
// parameter
//		Ȃ
// retun
//		0:\ȃf[^i[ĂȂȂ 1:͐ -1:͎s
//----------------------------------------------
int CSendFileThread::AnalyzeCmd()
{
	int			iRet = 0;
	HeaderRec	Header;
	WORD		wCmd;
	int			iSize = m_pCRingBuffCmd->GetReadableSize();
	int			iPacketSize, iDataSize;
	LPBYTE		pbPacket = NULL;

	if (iSize < sizeof(HeaderRec))			// wb_TCYɖȂƂ͉Ȃ
		goto L_END;

	// wb_؂ǂݍ݂(pPbgۂƊi[Ă͂)
	m_pCRingBuffCmd->ReadWithoutUpdateHeadPoint((LPBYTE)&Header, sizeof(HeaderRec));
	wCmd = ntohs(Header.wCommand);
	iDataSize = ntohs(Header.wDataLen);
	iPacketSize = iDataSize + sizeof(HeaderRec);
	if (iSize < iPacketSize)				// pPbgTCYɖȂƂ͉Ȃ
		goto L_END;

	pbPacket = (LPBYTE)calloc(iPacketSize, sizeof(BYTE));
	// pPbgŜǂ
	m_pCRingBuffCmd->Read(pbPacket, iPacketSize);

	switch (wCmd)
	{
		case CMD_SEND_FILE_START_RES:			// MJnvM
			iRet = RecvSendFileStartResPacket((SendFileResRec *)pbPacket);
			break;
		case CMD_SEND_FILE_END_RES:				// MvM
			iRet = RecvSendFileEndResPacket((SendFileResRec *)pbPacket);
			break;
		case CMD_SEND_FILE_ABORT_RES:			// MfvM
			iRet = RecvSendFileAbortResPacket((SendFileResRec *)pbPacket);
			break;
		default:
			iRet = -1;
			break;
	}
L_END:
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMJnv
// parameter
//		Ȃ
// return
//		TRUE/FALSE
//----------------------------------------------
int CSendFileThread::RecvSendFileStartResPacket(SendFileResRec *pbPacket)
{
	int			iRet = 1;

	m_cSendFileStartRes = pbPacket->cResCode;
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMv
// parameter
//		Ȃ
// return
//		TRUE/FALSE
//----------------------------------------------
int CSendFileThread::RecvSendFileEndResPacket(SendFileResRec *pbPacket)
{
	int			iRet = 1;

	m_cSendFileEndRes = pbPacket->cResCode;
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMfv
// parameter
//		Ȃ
// return
//		TRUE/FALSE
//----------------------------------------------
int CSendFileThread::RecvSendFileAbortResPacket(SendFileResRec *pbPacket)
{
	int			iRet = 1;

	m_cSendFileAbortRes = pbPacket->cResCode;
	return(iRet);
}

//----------------------------------------------
// function
//    ̃Xbh̓]rԂ
//	  ʃXbhQƂ
// parameter
//    Ȃ
// return
//	  TRUE/FALSE
//----------------------------------------------
BOOL CSendFileThread::IsZombie()
{
	BOOL	fRet;

	m_pCMySyncObject->Lock();
	fRet = m_fIamZombie;
	m_pCMySyncObject->UnLock();
	return(fRet);
}

